/* author GEKU 2019 */
/* v2.1 */

#include <string.h>
#include <stdlib.h>

char *extract_word(unsigned char n, const char *pSrcStr, const char *pDelimiters, char *pDstStr)
/*- returns the n-th word of string, using pDelimiters */
{
    unsigned char count;
    char *po;
    char *pa;
	
    count = 0; /* counts then keyword */
    pa = pDstStr;
    po = NULL; /*points to the n'th keyword */
    if (pSrcStr == NULL) {} else
    {
        strcpy(pDstStr, pSrcStr);

        while ( *pDstStr != 0)
        {
            /* skip over pDelimiters */
            while ((strrchr(pDelimiters, *pDstStr) != NULL) && ( *pDstStr != 0))
            {
                if (count == n)
                {
                    *pDstStr = 0;
                    return (po);
                }
                pDstStr++;
            }
            /* if we're not beyond end of pDstStr, we're at the start of a keyword */
            if ( *pDstStr != 0)
            {
                count++;
                if (count == n)
                {
                    po = pDstStr; /* set pointer "po" to the start of the keyword */
                }
            }
            /* find the end of the current word, "pDstStr" points after the end of the keyword */
            while ((strrchr(pDelimiters, *pDstStr) == NULL) && ( *pDstStr != 0))
            {
                pDstStr++;
            }
        }
        /* returns a pointervalue to the start of the wanted keyword */
    }
    return (po);
}

int xchg2temp10(const char *px)
{
    char *py;

    if (py = strchr((char * ) px, '.'))
    {
        *py = *(py + 1);
        *(py + 1) = 0;
        return atoi(px);
    }
    else
    {
        return atoi(px) * 10;
    }
}
